#!/usr/bin/python

# This script is part of Emma project
#
# report_gnuplot.py takes report in emma-internal-format
# and writes it in gnuplot-format, so it can be for
# examples passed through a pipe to gnuplot and displayed
# onto the screen, like below:
# $ cat emma-report | report_gnuplot.py | gnuplot -persist - 

import string
import sys

#
# This part is responsible for reading input from Emma
#
sys.stdin.readline()

title = sys.stdin.readline()
title = title[:-1]

temp = string.split(sys.stdin.readline())
accounts_no = float(temp[0])
groups_no = float(temp[1])
del temp

accounts = []
for i in range(accounts_no):
    accounts.append(sys.stdin.readline())
    accounts[-1] = accounts[-1][:-1]

groups = []
for i in range(groups_no):
    groups.append(sys.stdin.readline())
    groups[-1] = groups[-1][:-1]

values = []
for i in range(accounts_no):
    values.append(map(float, string.split(sys.stdin.readline())))

#
# Actual conversation with gnuplot takes place below
#
print "# --------------------- GENERAL SETUP"
print "set data style lines"
print "set title '%s'" % title

print "# --------------------- XAXIS LABELS"
print "set xtics ( \\"
for grp in range(groups_no):
    print "\t'%s' %d" % (groups[grp], grp),
    if grp <> (groups_no - 1): print ",",
    print "\\" 
print ")"

print "# --------------------- PLOTTING"
print "plot \\"
for acc in range(accounts_no):
    print "\t'-' title '%s'" % accounts[acc],
    if acc <> (accounts_no - 1):
        print ", \\"
    else:
        print

for acc in range(accounts_no):
    print "# --------------------- PLOTTING - SET %d" % acc
    for grp in range(groups_no):
        print "\t%d\t%.2f" % (grp, values[acc][grp])
    print "e"
    
